﻿//Keats Robison - May 2, 2013
//
//Just learning fo-dicom by trying to writing some small test programs 
//as there are not very many examples out there that show the basics of usnig this library.
//
//This was tested to a Siemens syngoxs workstation ver VA60B and so far works well.
//Not even sure this is the correct way of doing a CreatStudyQuery (think so), 
//if there is a better way please show the simplified code.
//
//
/* "The PACS sends one C-FIND response for every result record. 
    While still running, the status field of the C-FIND response command is 'pending' (0xFF00). 
    The last response has a status success." 
*/
//This is free code for anyone to use...

//So far the only thing this program does is query for a patient, list the first patients study and then clicking on the study shows the series.
//The cMove to get the patient/studies from the syngoxs workstation now works.
//The cStore SCU (Get Patient Button) works but is very slow, not sure how to send a status of "Pending" back to the SCP.
//


using System;
using System.Threading;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows;
using System.Xml;
using System.Xml.Serialization;

using Dicom;
using Dicom.Log;
using Dicom.Network;
using Dicom.Imaging;
using Dicom.Imaging.Codec;
using Dicom.IO.Buffer;


namespace Query_Retrieve_Tool
{
    public partial class Form1 : Form
    {
        static Boolean Complete; //for query while loop
        static Boolean QueryMatch = true; //tests if query matches

        //When using the '*' wildcard, the 'First' boolean variable captures the very first patient and patientid in variables patname and patid
        //which allows the display of the studies for this very first patient in the list.
        static Boolean First = true;
        static string patname, patid;  //for use with First above

        static string StudyInsUid, SeriesInsUid;

        //These are temporary and will be replaced when I get the Nodes db working so you can select the node
        //you want to connect to, until then change these to match you environment. 
        static string remotehost = "172.18.26.29";
        static string callingAET = "KEATSTEST";
        static string calledAET = "MVTEST";
        static Int16 port = 104;

        //http://dicomserver.co.uk/logs
        //static string remotehost = "87.106.65.167";
        //static string callingAET = "KEATSTEST";
        //static string calledAET = "DICOMSERVER";
        //static Int16 port = 104;
        //

        public Form1()
        {
            InitializeComponent();
            study_dataGridView.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            CStorSCP StoreSCP = new CStorSCP();
            StoreSCP.StartDicomServer();
        }

        #region GUI Buttons

        private void Query_button_Click_1(object sender, EventArgs e)
        {
            pat_dataGridView.Rows.Clear();
            study_dataGridView.Rows.Clear();
            series_dataGridView.Rows.Clear();

            patname = patid = "";

            if ((pat_nam_textBox.Text == "") && (pat_id_textBox.Text == ""))
            {
                MessageBox.Show("There are no parameters for the Patient Query Search ...!", "Query Not Possible",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            else
            {
                //Resets First for new query
                First = true;
                //Resets the Complete flag so you can query again
                QueryMatch = true;
                Complete = false;
                //ThreadPool.QueueUserWorkItem(new WaitCallback(PatientQuery)); //doesn't work correctly - will work on latter
                PatientQuery();
                if (QueryMatch == true)
                {
                    //Resets the Complete flag so you can query again
                    Complete = false;
                    //ThreadPool.QueueUserWorkItem(new WaitCallback(StudyQuery)); //doesn't work correctly - will work on latter
                    StudyQuery();
                }
            }

        }

        private void Get_Pat_button_Click(object sender, EventArgs e)
        {

            GetPat GP = new GetPat();
            GP.GetPatient(remotehost, port, callingAET, calledAET, patid, StudyInsUid, SeriesInsUid);
        }

        private void Store_Patient_button_Click(object sender, EventArgs e)
        {
            List<string> ImageList = new List<string>();

            foreach (string ImageName in Directory.GetFiles(@"C:\Users\Keats\Dicom\1.2.124.113532.54405.25716.7710.20121106.14750.40203990", "*.dcm"))
            {
                ImageList.Add(ImageName);
            }
            CStoreSCU MyStore = new CStoreSCU();
            MyStore.CStore_SCU(remotehost, port, callingAET, calledAET, ImageList);
        }
        #endregion GUI Buttons



        #region PatientQuery

        public void PatientQuery()
        //public void PatientQuery(Object o)
        {
            //Patient Query
            while (Complete != true)
            {
                try
                {
                    DicomCFindRequest request = DicomCFindRequest.CreatePatientQuery(patientId: pat_id_textBox.Text, patientName: pat_nam_textBox.Text);
                    DicomCFindRequest.ResponseDelegate cFindResponseDelegate = PatientListResponse;
                    request.OnResponseReceived = cFindResponseDelegate;

                    DicomClient client = new DicomClient();
                    client.AddRequest(request);
                    client.Send(remotehost, port, false, callingAET, calledAET);
                }
                catch (Exception ex)
                {
                    //No exception thrown if patient not found.....?
                    MessageBox.Show("PatientQuery Exception " + ex.ToString());
                }

            }
        }

        //Patientlist response delegate
        public void PatientListResponse(DicomCFindRequest request, DicomCFindResponse response)
        {
            string Patient;
            string Patient_ID;
            string Sex;
            string Birthdate;

            // this keeps the NULL exception from happening at the end of the query
            if (response.Status.ToString() == "Success")
            {
                //This catches a no query match - these two strings will be empty if no dataset is returned.
                //
                //Note: PS 3.4 C.4.1.2.1 - 1500 - SCP - When there are no matches, then no responses with a status of Pending are sent, 
                //only a single response with a status of Success.
                //Note: PS 3.4 C.4.1.3.2.2 - 1565 - SCU - 1565 e) Otherwise, if there are no matches, return a response with status 
                //equal to Success and no Identifier ie., response.Dataset.Get<string>(DicomTag.PatientName) etc.
                //
                //I found that trying "if (response.Dataset.Get<string>(DicomTag.PatientName) == "")" hangs the program.

                if ((patname == "") && (patid == "") && (response.Status.ToString() == "Success"))
                {
                    MessageBox.Show("There are no matches for this Patient Query ...!  " +
                    "Patient Name : " + pat_nam_textBox.Text + " --- " + "PatientID : " + pat_id_textBox.Text + " !", "Query Not Matched",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    QueryMatch = false;
                }

                Complete = true;
                return;

            }
            else
            {
                //"First" a boolean variable captures the very first patient and patientid in variables patname and patid
                //which allows the display of the studies for this first patient.
                if (First == true)
                {
                    patname = Patient = response.Dataset.Get<string>(DicomTag.PatientName);
                    patid = Patient_ID = response.Dataset.Get<string>(DicomTag.PatientID);
                    Sex = response.Dataset.Get<string>(DicomTag.PatientSex);
                    Birthdate = response.Dataset.Get<string>(DicomTag.PatientBirthDate);
                    First = false;
                }
                else
                {
                    Patient = response.Dataset.Get<string>(DicomTag.PatientName);
                    Patient_ID = response.Dataset.Get<string>(DicomTag.PatientID);
                    Sex = response.Dataset.Get<string>(DicomTag.PatientSex);
                    Birthdate = response.Dataset.Get<string>(DicomTag.PatientBirthDate);
                }

                //Have to do BeginInvoke here because we are not in the GUI (main) thread
                if (pat_dataGridView.InvokeRequired)
                {
                    pat_dataGridView.BeginInvoke(new MethodInvoker(delegate
                    {
                        pat_dataGridView.Rows.Add(Patient, Patient_ID, Sex, Birthdate);
                    }));
                }
            }

        }

        #endregion PatientQuery



        #region StudyQuery


        //private void StudyQuery(Object o)
        private void StudyQuery()
        {
            while (Complete != true)
            {
                try
                {
                    DicomCFindRequest study_request = DicomCFindRequest.CreateStudyQuery(patientName: patname, patientId: patid);
                    DicomCFindRequest.ResponseDelegate cFindResponseDelegate = StudyListResponse;
                    DicomClient client = new DicomClient();
                    study_request.OnResponseReceived = cFindResponseDelegate;
                    client.AddRequest(study_request);
                    client.Send(remotehost, port, false, callingAET, calledAET);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("StudyQuery Exception " + ex.ToString());
                }
            }
        }

        //studylist response delegate
        public void StudyListResponse(DicomCFindRequest request, DicomCFindResponse response)
        {
            // this keeps the NULL exception from happening at the end of the query
            if (response.Status.ToString() == "Success")
            {
                Complete = true;
                return;
            }
            else
            {
                string Patient = response.Dataset.Get<string>(DicomTag.PatientName);
                string Patient_ID = response.Dataset.Get<string>(DicomTag.PatientID);
                string Sex = response.Dataset.Get<string>(DicomTag.PatientSex);
                string Birthdate = response.Dataset.Get<string>(DicomTag.PatientBirthDate);
                string Accession = response.Dataset.Get<string>(DicomTag.AccessionNumber);
                string Modality = response.Dataset.Get<string>(DicomTag.Modality);
                string Study_Date = response.Dataset.Get<string>(DicomTag.StudyDate);
                string Study_Time = response.Dataset.Get<string>(DicomTag.StudyTime);
                string Study_Desc = response.Dataset.Get<string>(DicomTag.StudyDescription);
                string NumberOfStudyInst = response.Dataset.Get<string>(DicomTag.NumberOfStudyRelatedInstances);
                string StudyInstUid = response.Dataset.Get<string>(DicomTag.StudyInstanceUID);
                StudyInsUid = response.Dataset.Get<string>(DicomTag.StudyInstanceUID);
                //Have to do BeginInvoke here because we are not in the GUI (main) thread
                if (study_dataGridView.InvokeRequired)
                {
                    study_dataGridView.BeginInvoke(new MethodInvoker(delegate
                    {
                        study_dataGridView.Rows.Add(Patient, Patient_ID, Sex, Birthdate, Accession, Modality, Study_Date, Study_Time, Study_Desc, NumberOfStudyInst, StudyInstUid);
                    }));
                }

            }

        }

        #endregion StudyQuery



        #region SeriesQuery

        private void SeriesQuery(string studyuid)
        {
            while (Complete != true)
            {
                //DicomCFindRequest dimse = new DicomCFindRequest(DicomQueryRetrieveLevel.Image);
                try
                {
                    DicomCFindRequest series = DicomCFindRequest.CreateSeriesQuery(studyInstanceUid: studyuid);
                    DicomCFindRequest.ResponseDelegate cFindResponseDelegate1 = SeriesListResponse;
                    DicomClient client1 = new DicomClient();
                    series.OnResponseReceived = cFindResponseDelegate1;
                    client1.AddRequest(series);
                    client1.Send(remotehost, port, false, callingAET, calledAET);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("SeriesQuery Exception " + ex.ToString());
                }
            }
        }

        //serieslist response delegate
        public void SeriesListResponse(DicomCFindRequest request, DicomCFindResponse response)
        {
            // this keeps the NULL exception from happening at the end of the query
            if (response.Status.ToString() == "Success")
            {
                Complete = true;
                return;
            }
            else
            {
                string Series_Number = response.Dataset.Get<string>(DicomTag.SeriesNumber);
                string Series_Description = response.Dataset.Get<string>(DicomTag.SeriesDescription);
                string Modality = response.Dataset.Get<string>(DicomTag.Modality);
                string Series_Date = response.Dataset.Get<string>(DicomTag.SeriesDate);
                string Series_Time = response.Dataset.Get<string>(DicomTag.SeriesTime);
                string Number_Of_Images = response.Dataset.Get<string>(DicomTag.NumberOfSeriesRelatedInstances);
                string SeriesInstance_UID = response.Dataset.Get<string>(DicomTag.SeriesInstanceUID);
                SeriesInsUid = response.Dataset.Get<string>(DicomTag.SeriesInstanceUID);

                //Have to do BeginInvoke here because we are not in the GUI (main) thread
                if (series_dataGridView.InvokeRequired)
                {
                    series_dataGridView.BeginInvoke(new MethodInvoker(delegate
                    {
                        series_dataGridView.Rows.Add(Series_Number, Series_Description, Modality, Series_Date, Series_Time, Number_Of_Images, SeriesInstance_UID);
                    }));
                }
            }
        }
        #endregion SeriesQuery



        #region Datagrid Selections

        //pat_dataGridView_CellContentClick_1
        //with more than one patient in the list - just click on a patient to see the related studies. 

        private void pat_dataGridView_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {
            int rowIndex = e.RowIndex;
            study_dataGridView.Rows.Clear();
            series_dataGridView.Rows.Clear();
            series_dataGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;

            //DataGridViewRow row = Study_dataGridView.Rows[rowIndex];
            patname = pat_dataGridView.Rows[rowIndex].Cells[0].Value.ToString();
            patid = pat_dataGridView.Rows[rowIndex].Cells[1].Value.ToString();

            while (Complete != true)
            {
                try
                {
                    DicomCFindRequest series = DicomCFindRequest.CreateStudyQuery(patientName: patname, patientId: patid);
                    DicomCFindRequest.ResponseDelegate cFindResponseDelegate1 = StudyListResponse;
                    DicomClient client1 = new DicomClient();
                    series.OnResponseReceived = cFindResponseDelegate1;
                    client1.AddRequest(series);
                    client1.Send(remotehost, port, false, callingAET, calledAET);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("pat_dataGridView_click Exception " + ex.ToString());
                }
            }

            //Resets the Complete flag so you can query again
            Complete = false;
            patname = patid = "";
        }

        /*************************************************************************************************************************/

        //Study_dataGridView_CellContentClick
        //with more than one study in the list - just click on the study to see the related series.

        private void Study_dataGridView_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            Complete = false;
            string StudyInstUid;
            int rowIndex = e.RowIndex;
            series_dataGridView.Rows.Clear();
            series_dataGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;

            //This gets the StudyInstUid from the selected row on the study_dataGridView
            DataGridViewRow row = study_dataGridView.Rows[rowIndex];
            StudyInstUid = study_dataGridView.Rows[rowIndex].Cells[10].Value.ToString();

            while (Complete != true)
            {
                try
                {
                    DicomCFindRequest series = DicomCFindRequest.CreateSeriesQuery(studyInstanceUid: StudyInstUid);
                    DicomCFindRequest.ResponseDelegate cFindResponseDelegate1 = SeriesListResponse;
                    DicomClient client1 = new DicomClient();
                    series.OnResponseReceived = cFindResponseDelegate1;
                    client1.AddRequest(series);
                    client1.Send(remotehost, port, false, callingAET, calledAET);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Study_dataGridView_click Exception " + ex.ToString());
                }
            }

            //Resets the Complete flag so you can query again
            Complete = false;
        }

        #endregion Datagrid Selections

    }
}